package com.zt.plat.module.qms.business.reportdoc.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.qms.business.bus.dal.dataobject.BusinessAssayReportDataDO;
import com.zt.plat.module.qms.business.reportdoc.controller.vo.*;
import com.zt.plat.module.qms.business.reportdoc.dal.dataobject.ReportDocumentDataDO;
import com.zt.plat.module.qms.business.reportdoc.dal.dataobject.ReportDocumentMainDO;
import com.zt.plat.module.qms.business.reportdoc.dal.dataobject.ReportDocumentTypeDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 检测报告明细 Service 接口
 *
 * @author 后台管理
 */
public interface ReportDocumentDataService {

    CommonResult<JSONArray> assembleDynamicData(ReportDocumentMainDO mainData, ReportDocumentTypeDO reportConfig, String pageFlag);

    CommonResult<JSONArray> assembleByReportData(JSONObject jsonObject);

    CommonResult<List<ReportDocumentDataDO>> listByMainDataId(Long mainDataId);
    CommonResult<Long> countMainDataId(Long mainDataId);
    CommonResult<String> removeByMainIdAndDetailIds(Long mainDataId, List<Long> detailIds);

    String assembleSignature(String docSig);

    /**
     * 创建检测报告明细
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ReportDocumentDataRespVO createReportDocumentData(@Valid ReportDocumentDataSaveReqVO createReqVO);


    CommonResult<String> insertBatch(List<ReportDocumentDataDO>  list);

    void deleteByMainId(Long mainId);

    /**
     * 更新检测报告明细
     *
     * @param updateReqVO 更新信息
     */
    void updateReportDocumentData(@Valid ReportDocumentDataSaveReqVO updateReqVO);

    void updateBatch(List<ReportDocumentDataSaveReqVO>  list);

    /**
     * 删除检测报告明细
     *
     * @param id 编号
     */
    void deleteReportDocumentData(Long id);

    /**
     * 批量删除检测报告明细
     *
     * @param ids 编号
     */
    void deleteReportDocumentDataListByIds(List<Long> ids);

    /**
     * 获得检测报告明细
     *
     * @param id 编号
     * @return 检测报告明细
     */
    ReportDocumentDataDO getReportDocumentData(Long id);

    /**
     * 获得检测报告明细分页
     *
     * @param pageReqVO 分页查询
     * @return 检测报告明细分页
     */
    PageResult<ReportDocumentDataDO> getReportDocumentDataPage(ReportDocumentDataPageReqVO pageReqVO);

}